
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <stdio.h>
#include <stdlib.h>

// digit pattern for a 7-segment display
const uint8_t digit_pattern[16] =
	{
		0b00111111, // 0
		0b00000110, // 1
		0b01011011, // 2
		0b01001111, // 3
		0b01100110, // 4
		0b01101101, // 5
		0b01111101, // 6
		0b00000111, // 7
		0b01111111, // 8
		0b01101111, // 9
		0b01110111, // A
		0b01111100, // b
		0b00111001, // C
		0b01011110, // d
		0b01111001, // E
		0b01110001  // F
};

volatile uint8_t counter = 0;
uint8_t digits[2];
void get_digits(uint8_t num, uint8_t ndigits);
void output_7segment(uint8_t val);
void switch_digit(uint8_t dig);

/* Timer1 Output Compare Interrupt A */
ISR(TIMER1_COMPA_vect)
{
}

/* pin change interrupt on PORTD */
ISR(PCINT3_vect)
{
}

/* initialize GPIO inputs and outputs */
void IO_init()
{
	DDRD |= (1 << PD4);
	PORTD &= ~(1 << PD4);
}

/* initializeaza timer-ul 1 */
void timer1_init()
{
	// initialize the timer counter
	TCNT1 = 0;
	// configure the threshold
	OCR1A = 10000;
	// enable compare interrupt A
	TIMSK1 = (1 << OCIE1A);
	// configure mode of operation e.g. CTC with OCR1A
	TCCR1B = (1 << WGM12);
	// set the prescaler e.g 256
	TCCR1B |= (1 << CS12);
}

int main(void)
{
	// init peripherals
	IO_init();
	_delay_ms(1000);
	timer1_init();
	sei();

	// power on test
	PORTD |= (1 << PD4);
	_delay_ms(500);
	PORTD &= ~(1 << PD4);
	_delay_ms(500);

	// main loop
	while (1)
	{
		// convert the number to digits
		// drive the 7-segment display one digit at a time with a delay in between
	}

	return 0;
}
